
from twisted.application import service
from twisted.words.protocols.jabber import component

from gadget.component import GadgetService
from gadget.config import read_config
from gadget.model import GadgetModel
from gadget.roster import GadgetRoster

def read_config_():
    config = None

    for path in ('gadget.config', '/etc/gadget/gadget.config'):
        try:
            config = read_config(path)
        except IOError:
            continue
        else:
            break

    if config is None:
        raise RuntimeError("failed to find configuration file")

    return config

config = read_config_()
domain = config['domain']
password = config['password']
strport = 'tcp:%s:%d' % (config['server_host'], config['server_port'])
model = GadgetModel()
roster = GadgetRoster(config['roster_path'])

application = service.Application("gadget")

manager = component.buildServiceManager(domain, password, strport)
manager.setServiceParent(application)

service = GadgetService(model, roster)
service.setServiceParent(manager)

